"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TPhrasing = exports.default = void 0;

var _HTMLContentModel = _interopRequireDefault(require("../model/HTMLContentModel"));

var _TNodeCtor = _interopRequireDefault(require("./TNodeCtor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isChildEmpty(c) {
  return c.isEmpty();
}

const TPhrasing = function TPhrasing(init) {
  this.initialize(init);
}; //@ts-ignore


exports.TPhrasing = TPhrasing;
TPhrasing.prototype = new _TNodeCtor.default('phrasing', 'TPhrasing');

TPhrasing.prototype.matchContentModel = function matchContentModel(contentModel) {
  return contentModel === _HTMLContentModel.default.textual || contentModel === _HTMLContentModel.default.mixed;
};

TPhrasing.prototype.isEmpty = function isEmpty() {
  // Only anonymous phrasing nodes with every children empty can be considered "empty"
  return this.tagName === null && this.children.every(isChildEmpty);
};

TPhrasing.prototype.collapseChildren = function collapseChildren(params) {
  let previous = null;
  let indexesToSplice = [];
  this.children.forEach((childK, k) => {
    const j = k - 1;
    childK.collapse(params);

    if (j > -1 && childK.isCollapsibleLeft() && previous.isCollapsibleRight()) {
      previous.trimRight();

      if (previous.isEmpty()) {
        indexesToSplice.push(j);
      }
    }

    previous = childK;
  });
  this.spliceChildren(indexesToSplice);
  this.trimLeft();
  this.trimRight();
  return null;
};

var _default = TPhrasing;
exports.default = _default;
//# sourceMappingURL=TPhrasing.js.map